--- create_compressed_fs.c.orig	Thu Jan 15 10:34:31 2004
+++ create_compressed_fs.c	Thu Jan 15 10:59:23 2004
@@ -18,7 +18,30 @@
 #include <stdlib.h>
 #include <string.h>
 #include <sys/stat.h>
+#if defined(__FreeBSD__)
+#include <sys/endian.h>
+#include <netinet/in.h>
+typedef uint64_t loff_t;
+#ifndef htobe64
+static __inline __uint64_t
+__bswap64(__uint64_t _x)
+{
+
+	return ((_x >> 56) | ((_x >> 40) & 0xff00) | ((_x >> 24) & 0xff0000) |
+	    ((_x >> 8) & 0xff000000) | ((_x << 8) & ((__uint64_t)0xff << 32)) |
+	    ((_x << 24) & ((__uint64_t)0xff << 40)) |
+	    ((_x << 40) & ((__uint64_t)0xff << 48)) | ((_x << 56)));
+}
+#if BYTE_ORDER == LITTLE_ENDIAN
+#define htobe64(x)	__bswap64(x)
+#else
+#define htobe64(x)
+#endif
+#endif
+#define __cpu_to_be64 htobe64
+#else
 #include <asm/byteorder.h>
+#endif
 #include <fcntl.h>
 #include <zlib.h>
 #include "compressed_loop.h"
